<div class="message" class:sending="!id">
  <div class="message-header">
    <div class="message-detail">
      <ContextMenu choices={authorContextChoices}>
  <span class="user-avatar">
    <UserAvatar userId={authorId} />
  </span>
  <h2 class="username">
    {#if displayName}
    {displayName}
    {:elseif userPromise}
    {#await userPromise}
    {authorId}
    {:then user}
    {user.username}
    {:catch err}
    Oopsie Woopsie, {authorId}: {err.message}
    {/await}
    {/if}
  </h2>
      </ContextMenu>
      <span class="message-time">
        {relativeDate}
      </span>
    </div>
  </div>
  <div
    class:mentions="content.includes('<@' + $userId + '>') || content.includes('@everyone')"
    class="message-content">
    {#if editing}
    <ChannelInput messageContent={content}
      channelName={$channel.name}
      editing={id}
      className="channel-input editing-channel-input"
      on:edit="fire('edit', event)"
      channelId={$channel.id} />
    {:else}
    <ContextMenu choices={contextChoices}>
      <MarkdownParser {content} />
    </ContextMenu>
    {/if}
  </div>
  <div class="message-attachments">
    {#each attachments as attachment (attachment.id)}
    {#if attachment.uploaded !== false}
    <AttachmentPreview {attachment} on:load="fire('attachmentLoad')" />
    {/if}
    {/each}
    {#if embeds && embeds.length}
    {#each embeds as embed (embed.id)}
    <MessageEmbed type={embed.type}
                  {embed}
                  id={embed.id}
                  link={embed.link}
                  title={embed.title}
                  color={embed.color}
                  description={embed.description}

                  player={embed.player}
                  image={embed.image}

                  playerHeight={embed.height}
                  playerWidth={embed.width} />
    {/each}
    {/if}
    {#if gameId}
    {#if playingGame}
    <GamePlayer {gameId}
                options={gameOptions}
                on:setGame="setGame(id, event)" />
    {:else}
    <div class="game-invitation"
         on:mouseenter="set({lighten: true})"
         on:mouseleave="set({lighten: false})"
         on:click="set({playingGame: true})">
      <div class="game-icon-bg"
           style={`background-image: url(${gameIconURL})`} />
      <div class="centered">
        <div class="play-icon">
          <PlayIcon {lighten} />
        </div>
        <div class="invitation-text">
          Play Game
        </div>
      </div>
    </div>
    {/if}
    {/if}
  </div>
</div>

<script>
  import MarkdownParser from "./MarkdownParser.svelte";
  import UserStore from "../stores/UserStore";
  import ChannelInput from "./ChannelInput.svelte";
  import UserAvatar from "./UserAvatar.svelte";
  import AttachmentPreview from "./AttachmentPreview.svelte";
  import SnowflakeUtils from "../js/SnowflakeUtils";
  import ContextMenu from "./ContextMenu.svelte";
  import RestClient from "../js/RestClient";
  import ChannelMessageStore from "../stores/ChannelMessageStore";
  import ManageRolesModal from "./modals/ManageRolesModal.svelte";
  import env from "../js/constants";

  const games = new Map();

  export default {
    components: {
      MarkdownParser,
      UserAvatar,
      ContextMenu,
      ChannelInput,
      AttachmentPreview,
      GamePlayer: "./games/GamePlayer.svelte",
      PlayIcon: "./icons/PlayIcon.svelte",
      MessageEmbed: "./MessageEmbed.svelte"
    },

    onupdate({current, changed}) {
      if (changed.id && current.gameId) {
        this.set({
          playingGame: !!games.get(current.id)
        });
      } else if (changed.playingGame) {
        games.set(current.id, current.playingGame);
      }
    },

    methods: {
      setGame(messageId, event) {
        this.set({playingGame: false});
        console.log("setGame", event);
        this.fire("setGame", event);
      }
    },

    oncreate() {
      const got = this.get();

      let userPromise;

      if (got.displayName === undefined) {
        const userId = got.authorId;
        const gotUser = UserStore.getUser(userId);
        userPromise = gotUser || UserStore.fetchUser(userId);
      }
  
      this.set({
        // gameId: true,
        userPromise,
        authorContextChoices: [
          {
            text: "Manage Roles",
            click: () =>
              this.store.set({
                modal: {
                  component: ManageRolesModal,
                  options: this.get().authorId
                }
              })
          },
          {
            text: "Copy ID",
            click: () => alert(this.get().authorId)
          }
        ],
        contextChoices: [
          {
            text: "Edit Message",
            click: () => this.fire("edit", this.get().id),
            hide: this.get().authorId != this.store.get().userId
          },
          {
            text: "Delete Message",
            click: async () => {
              const {id} = this.get();
              await RestClient.delete(
                `/channels/${this.store.get().channel.id}/messages/${id}`
              );
              ChannelMessageStore.unslurp({id});
            },
            color: "#b03"
          },
          {
            text: "Copy ID",
            click: () => alert(this.get().id)
          }
        ]
      });
    },
    computed: {
      gameIconURL({gameId}) {
        return `${env.API_BASE}/games/${gameId}/assets/icon`;
      },
      sendTime({id, nonce}) {
        return SnowflakeUtils.when(nonce || id);
      },
      relativeDate({sendTime}) {
        return `${sendTime.toLocaleDateString()} ${sendTime.toLocaleTimeString()}`;
      }
    }
  };
</script>

<style>
  .message:not(:last-child):after {
  background-color: #2f3336;
  content: "";
  height: 1px;
  width: 100%;
  display: block;
  margin-top: 0.5em;
  }
  .username {
  margin: 0;
  font-size: 1rem;
  display: inline-block;
  }
  .message-content {
  font-size: 1rem;
  }
  .message {
    margin-left: 1.5em;
    margin-right: 1.5em;
    margin-bottom: 0.5em;
  }
  .message:last-child {
    margin-bottom: 0.35em;
  }
  .message.sending .message-content {
    color: #949494;
  }

  .message-time {
    font-size: 0.58em;
    color: #909090;
  }

  .message-detail {
    display: inline-block;
    vertical-align: top;
  }

  .message-content.mentions {
    background-color: rgba(218, 218, 30, 0.3);
    border-left: 4px solid #d0ff25;
    border-top-left-radius: 2px;
    padding-left: 0.2em;
    border-bottom-left-radius: 2px;
  }

  .game-invitation {
    margin: 0.25em 0;
    max-width: 100%;
    height: 150px;
    width: 300px;
    cursor: pointer;
    position: relative;
  }

  .centered,
  .game-invitation,
  .game-icon-bg {
    border-radius: 5px;
  }

  .centered:hover {
    background: #0008;
  }

  .centered {
    background: #0006;
    position: absolute;
    transition: background 0.2s ease-out;
    text-align: center;
    height: 4em;
    width: 100%;
    padding: calc((150px - 4em) / 2) 0;
  }

  .game-icon-bg {
    background: #444;
    height: 100%;
    width: 100%;
    position: absolute;

    background-position: center;
    background-size: cover;
    background-repeat: no-repeat;
  }
</style>
